'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _Dropdown2 = require('uxcore/lib/Dropdown');

var _Dropdown3 = _interopRequireDefault(_Dropdown2);

var _Icon2 = require('uxcore/lib/Icon');

var _Icon3 = _interopRequireDefault(_Icon2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _rcTree = require('rc-tree');

var _rcTree2 = _interopRequireDefault(_rcTree);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var LOAD_STATUS_LOADING = 1;

var DropdownTreeNode = function (_RcTree$TreeNode) {
  _inherits(DropdownTreeNode, _RcTree$TreeNode);

  function DropdownTreeNode(props) {
    _classCallCheck(this, DropdownTreeNode);

    var _this = _possibleConstructorReturn(this, _RcTree$TreeNode.call(this, props));

    _this.renderSelector = function () {
      var _this$state = _this.state,
          loadStatus = _this$state.loadStatus,
          dragNodeHighlight = _this$state.dragNodeHighlight;
      var _this$props = _this.props,
          title = _this$props.title,
          selected = _this$props.selected,
          icon = _this$props.icon;
      var _this$context$rcTree = _this.context.rcTree,
          prefixCls = _this$context$rcTree.prefixCls,
          showIcon = _this$context$rcTree.showIcon,
          treeIcon = _this$context$rcTree.icon,
          draggable = _this$context$rcTree.draggable,
          loadData = _this$context$rcTree.loadData;

      var disabled = _this.isDisabled();

      var wrapClass = prefixCls + '-node-content-wrapper';

      // Icon - Still show loading icon when loading without showIcon
      var $icon = void 0;

      if (showIcon) {
        var currentIcon = icon || treeIcon;

        $icon = currentIcon ? _react2["default"].createElement(
          'span',
          {
            className: (0, _classnames2["default"])(prefixCls + '-iconEle', prefixCls + '-icon__customize')
          },
          typeof currentIcon === 'function' ? _react2["default"].createElement(currentIcon, _this.props) : currentIcon
        ) : _this.renderIcon();
      } else if (loadData && loadStatus === LOAD_STATUS_LOADING) {
        $icon = _this.renderIcon();
      }

      // Title
      var $title = _react2["default"].createElement(
        'span',
        { className: prefixCls + '-title' },
        _this.renderTitle()
      );

      return _react2["default"].createElement(
        'span',
        {
          ref: _this.setSelectHandle,
          title: typeof title === 'string' ? title : '',
          className: (0, _classnames2["default"])('' + wrapClass, _this.getNodeState() ? wrapClass + '-' + (_this.getNodeState() || 'normal') : '', !disabled && (selected || dragNodeHighlight) && prefixCls + '-node-selected', !disabled && draggable && 'draggable'),
          draggable: !disabled && draggable || undefined,
          'aria-grabbed': !disabled && draggable || undefined,

          onMouseEnter: _this.onMouseEnter,
          onMouseLeave: _this.onMouseLeave,
          onContextMenu: _this.onContextMenu,
          onClick: _this.onSelectorClick,
          onDragStart: _this.onDragStart
        },
        $icon,
        $title
      );
    };

    return _this;
  }

  // Icon + Title


  DropdownTreeNode.prototype.renderTitle = function renderTitle() {
    var _this2 = this;

    var _props = this.props,
        title = _props.title,
        onDropDownClick = _props.onDropDownClick,
        dropDownTitle = _props.dropDownTitle,
        dropDownOverlay = _props.dropDownOverlay,
        dropDownable = _props.dropDownable;
    var prefixCls = this.context.rcTree.prefixCls;


    if (dropDownable) {
      return _react2["default"].createElement(
        'span',
        {
          className: (0, _classnames2["default"])(prefixCls + '-dropdown-section'), ref: function ref(e) {
            _this2.dropDownSectionDom = e;
          }
        },
        _react2["default"].createElement(
          'span',
          null,
          title
        ),
        _react2["default"].createElement(
          'div',
          {
            className: (0, _classnames2["default"])(prefixCls + '-dropdown-section-right-section')
          },
          !!dropDownOverlay ? _react2["default"].createElement(
            _Dropdown3["default"],
            {
              overlayClassName: (0, _classnames2["default"])(prefixCls + '-dropdown-menu'), overlay: dropDownOverlay, getPopupContainer: function getPopupContainer() {
                return _this2.dropDownSectionDom;
              }
            },
            _react2["default"].createElement(_Icon3["default"], {
              className: (0, _classnames2["default"])(prefixCls + '-dropdown-section-icon'), name: 'shezhi'
            })
          ) : _react2["default"].createElement(_Icon3["default"], {
            className: (0, _classnames2["default"])(prefixCls + '-dropdown-section-icon'), name: 'zengjia', title: dropDownTitle, onClick: function onClick(e) {
              return onDropDownClick(e);
            }
          })
        )
      );
    }

    return title;
  };

  return DropdownTreeNode;
}(_rcTree2["default"].TreeNode);

DropdownTreeNode.propTypes = _extends({}, _rcTree2["default"].TreeNode.propTypes, {
  onDropDownClick: _propTypes2["default"].func,
  dropDownOverlay: _propTypes2["default"].node,
  dropDownTitle: _propTypes2["default"].string,
  dropDownable: _propTypes2["default"].bool
});

DropdownTreeNode.defaultProps = _extends({}, _rcTree2["default"].TreeNode.defaultProps, {
  onDropDownClick: function onDropDownClick() {},
  dropDownable: false
});

exports["default"] = DropdownTreeNode;
module.exports = exports['default'];